Subject: Re: [PATCH] [NIU] VLAN does not work with niu driver

From: Matheos Worku <[email-masked]>
Date: Wed, 09 Sep 2009 18:19:00 -0700

David Miller wrote:
> From: Matheos Worku <[email-masked]>
> Date: Wed, 09 Sep 2009 18:01:23 -0700
> 
>> The frame type in NIU HW is embedded in a HW header, so it is possible
>> to check the HW header and decide whether to pull up ETH_HLEN or VLAN
>> header size of bytes. However, considering the amount of work required
>> to get and examine the HW header (including endianess issues), we
>> thought pulling up 64 bytes by default (as used in cassini.c) would be
>> efficient.
> 
> Well, it was 64 in early versions of the driver, and I decreased it
> down to ETH_HLEN.
> 
> The less the better since for forwarding applications anything past
> the IPV4 header pulled is going to be a waste of CPU cache lines and
> thus negatively effect forwarding rates.
> 
> That's why I asked if this change was performance regression tested,
> because I know it's going to slow down forwarding rates for small
> packets.
Dave,

We did throughput testing (netperf) and didn't notice any performance 
degradation. We haven't done forwarding testing however.

We can work on a version which implements HW header checking and do 
pullup accordingly.

Regards,
Matheos

> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html